UNIT Aaprocs ;

INTERFACE

USES Wintypes,   {Weil der Typ hWnd benutzt wird}
     Controls,   {Weil der Typ TWinControl benutzt wird}
     SysUtils;   {Weil die Routine StrPCopy benutzt wird}

  function  aaOpen : integer ;         {Initialisieren der FLIC-DLL}
  procedure aaClose;                   {De-Initialisieren der FLIC-DLL}
  function  aaLoad   (filename : PChar ; WHand : hwnd ; Mode : word ;
                      x, y, wid, hght, orgx, orgy : integer) : integer ;
  function  aaPLoad  (filename : String; 
                      Control: TWinControl) : Integer;
  function  aaPlay   (AAhandle : integer) : integer ;
  function  aaPause  (AAhandle: Integer) : Integer;
  function  aaStop   (AAhandle : integer) : integer ;
  function  aaUnload (AAHandle : integer) : integer ;
  function  aaGetParm(AAhandle : integer ; wType: word) : LongInt;
  function  aaSetParm(AAhandle : integer ; wType: word;
                      HValue: Integer; LValue: LongInt) : LongInt;

  Const
  { Konstanten fr die Variable Mode der Funktion aaLoad}
    AA_None           = $00 ;  { Keiner der Modi                   }
    AA_MEMORYLOAD     = $01 ;  { Komplette Ani. i.d.Speicher laden }
    AA_HIDEWINDOW     = $02 ;  { Ani.Fenster verbergen             }
    AA_NOPALETTE      = $04 ;  { Keine Paletten-Animation          }
    AA_RESERVEPALLETE = $08 ;  { Palette reservieren               }
    AA_FULLSCREEN     = $20 ;  { Vollbilddarstellung               }
    AA_STOPNOTIFY     = $40 ;  { Keine Notify-Meldungen            }
    AA_STOPSTATUS     = $80 ;  { Keine Status-Meldungen            }
    AA_DONTPAINT      = $200;  { Keine Darstellung beim Laden d.Ani}
    AA_ALL            = $FF ;  { Alle Modi                         }

   {Mgliche Rckgabewerte der Funktionen aaGetParam, resp.
    Parameter der Funktion aaSetParam}
    AA_STATUS      = 1;        { Get aktuellen Status (s.u.)      }
    AA_MODE        = 3;        { Get/Set Animation Flags (s.o.)   }
    AA_WINDOW      = 4;        { Set/Get Animationsfenster        }
    AA_SPEED       = 5;        { Set/Get Abspielgeschwindigkeit   }
    AA_DESIGNSPEED = 6;        { Get Design-Abspielgeschwindigkeit}
    AA_FRAMES      = 7;        { Get Anzahl der Einzelbilder      }
    AA_POSITION    = 8;        { Set/Get aktuelle Bildnummer      }
    AA_LOOPS       = 9;        { Set/Get Anzahl der Schleifen     }
    AA_X           = 10;       { Set/Get Versatz nach rechts      }
    AA_Y           = 11;       { Set/Get Versatz nach unten       }
    AA_CX          = 12;       { Set/Get Breite sichtbarer Bereich}
    AA_CY          = 13;       { Set/Get Hhe   sichtbarer Bereich}
    AA_ORGX        = 14;       { Set/Get Versatz nach links       }
    AA_ORGY        = 15;       { Set/Get Versatz nach oben        }
    AA_WIDTH       = 16;       { Get Breite des Animationsfensters}
    AA_HEIGHT      = 17;       { Get Hhe des Animationsfensters  }
    AA_TRANSIN     = 21;       { Set/Get Transition In Typ (s.u.) }
    AA_TRANSOUT    = 22;       { Set/Get Transition Out Typ (s.u.)}
    AA_TIMEIN      = 23;       { Set/Get Transition In Zeit in ms }
    AA_TIMEOUT     = 24;       { Set/Get Transition OutZeit in ms }
    AA_ANIMWND     = 26;       { Get Animations Fenster-Handle    }
    AA_LASTERROR   = 1001;     { Get letzter Fehlercode           }

{aaGetParam-Rckgabewerte mit Parameter wType = AA_Status}
    AA_STOPPED = 1 ;           { Geladen aber angehalten          }
    AA_QUEUED  = 2 ;           { Animation wartet zu spielen      }
    AA_PLAYING = 3 ;           { Animation luft                  }
    AA_PAUSED  = 4 ;           { Animation ist angehalten         }
    AA_DONE    = 5 ;           { Animation ist beendet und wartet
                                 auf die aaStop-Anweisung}

{aaGetParam-Rckgabewerte/aaSetParam-Parameter wType = AA_TransIn
 /AA_TransOut}
    AA_CUT       = 0 ;         { Just stop one and start another  }
    AA_FADEBLACK = 1 ;         { Fade In/Out von/nach Schwarz     }
    AA_FADEWHITE = 2 ;         { Fade In/Out von/nach Wei        }

IMPLEMENTATION   {Wo findet Delphi die Funktionen}

  function  aaOpen ;    external 'AAPLAY' ;
  procedure aaClose ;   external 'AAPLAY' ;
  function  aaLoad ;    external 'AAPLAY' ;
  function  aaPLoad;
  Var P: Array[0..255] Of Char;
      H: Integer;
  Begin
    StrPCopy(P, filename); {Konvertiert String -> PChar}
    H := aaLoad(P, Control.Handle, 0,0,0,0,0,0,0);
    aaPause(H);  {Versetzen in den Pause-Zustand = Anzeigen des 1.Bildes}
    Result := H;
  End;

  function  aaUnload ;  external 'AAPLAY' ;
  function  aaPlay ;    external 'AAPLAY' ;
  function  aaStop ;    external 'AAPLAY' ;
  function  aaPause;    external 'AAPLAY' ;
  function  aaGetParm ; external 'AAPLAY' ;
  function  aaSetParm ; external 'AAPLAY' ;

END.



